package calc;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.Box;
import java.awt.GridLayout;
import javax.swing.JButton;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import java.awt.Color;
import java.awt.Component;
import javax.swing.JTextField;
import java.awt.Dimension;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Font;

public class CalcApp {

	private JFrame frame;
	private JTextField display;
	
	private CalcMain cm;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					CalcApp window = new CalcApp();
					window.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public CalcApp() {
		initialize();
		cm = new CalcMain();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frame = new JFrame();
		frame.setResizable(false);
		frame.setBounds(100, 100, 311, 187);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(new BoxLayout(frame.getContentPane(), BoxLayout.Y_AXIS));
		
		display = new JTextField();
		display.setFont(new Font("Lucida Grande", Font.PLAIN, 18));
		display.setHorizontalAlignment(SwingConstants.TRAILING);
		display.setText("0");
		display.setMaximumSize(new Dimension(2147483647, 36));
		display.setEditable(false);
		frame.getContentPane().add(display);
		display.setColumns(10);
		
		Box horizontalBox = Box.createHorizontalBox();
		frame.getContentPane().add(horizontalBox);
		
		JButton btn7 = new JButton("7");
		btn7.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 7, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox.add(btn7);
		
		JButton btn8 = new JButton("8");
		btn8.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 8, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox.add(btn8);
		
		JButton btn9 = new JButton("9");
		btn9.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 9, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox.add(btn9);
		
		JButton btnDiv = new JButton("/");
		btnDiv.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyOperator, 0, Operator.Div);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox.add(btnDiv);
		
		Box horizontalBox_1 = Box.createHorizontalBox();
		frame.getContentPane().add(horizontalBox_1);
		
		JButton btn4 = new JButton("4");
		btn4.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 4, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_1.add(btn4);
		
		JButton btn5 = new JButton("5");
		btn5.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 5, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_1.add(btn5);
		
		JButton btn6 = new JButton("6");
		btn6.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 6, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_1.add(btn6);
		
		JButton btnMul = new JButton("*");
		btnMul.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyOperator, 0, Operator.Mul);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_1.add(btnMul);
		
		Box horizontalBox_2 = Box.createHorizontalBox();
		frame.getContentPane().add(horizontalBox_2);
		
		JButton btn1 = new JButton("1");
		btn1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 1, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_2.add(btn1);
		
		JButton btn2 = new JButton("2");
		btn2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 2, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_2.add(btn2);
		
		JButton btn3 = new JButton("3");
		btn3.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 3, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_2.add(btn3);
		
		JButton btnMinus = new JButton("-");
		btnMinus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyOperator, 0, Operator.Minus);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_2.add(btnMinus);
		
		Box horizontalBox_3 = Box.createHorizontalBox();
		frame.getContentPane().add(horizontalBox_3);
		
		JButton btn0 = new JButton("0");
		btn0.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyNum, 0, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_3.add(btn0);
		
		JButton btnClr = new JButton("C");
		btnClr.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				cm.doState(Input.KeyClr, 0, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_3.add(btnClr);
		
		JButton btnEq = new JButton("=");
		btnEq.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyEq, 0, Operator.NoOp);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_3.add(btnEq);
		
		JButton btnPlus = new JButton("+");
		btnPlus.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cm.doState(Input.KeyOperator, 0, Operator.Plus);
				display.setText(String.valueOf(cm.getCurrent()));
			}
		});
		horizontalBox_3.add(btnPlus);
	}

}
